<?php

/**
 * Main Ajax Controller
 *
 * @link 		https://lin3s.com
 * @since 		1.0.0
 *
 * @package 	Alexandria_Conversation_Builder
 * @subpackage 	Alexandria_Conversation_Builder/admin/controllers
 */

if( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

// handle all ajax

function alexandria_conversation_builder_ajax() {

	$action = empty($_POST['alexandria_conversation_builder_action']) ? 'start' : $_POST['alexandria_conversation_builder_action'];
	
	switch($action) {
		// start conversation builder
		case 'start':
		default:
		echo MainController :: intiBuilder();
		break;
	}

	exit;
}

function alexandria_get_cutom_post_metadata_ajax() {

	$action = empty($_POST['alexandria_get_cutom_post_metadata_ajax']) ? 'metadata' : $_POST['alexandria_get_cutom_post_metadata_ajax'];
	
	switch($action) {
		// satr conversation builder
		case 'metadata':
		default:
		echo MainController :: getConversationMetadata();
		break;
	}

	exit;
}

function alexandria_process_contact_form() {

 	$text = preg_replace_callback('#{{(.*?)}}#',function($match) use ($variables){
        $match[1] = trim($match[1], '$');
        return $variables[$match[1]];
    },' ' . $template . ' ');

	$to = $_POST['email']; //sendto@example.com
	$subject = 'The subject';
	$body = 'The email body content';
	$headers = array('Content-Type: text/html; charset=UTF-8');

	wp_mail( $to, $subject, $body, $headers );

	exit;
	
}

function alexandria_add_interlocutor_ajax() {
	
	echo $_POST['interlocutor_title'];

	exit;
}

function alexandria_orden_tonos_ajax() {

	parse_str($_POST['order'], $data);

	if (!is_array($data))
		return false;

	$id_arr = array();
	foreach ($data as $key => $values) {
		foreach ($values as $position => $id) {
			$id_arr[] = $id;
		}
	}

	$menu_order_arr = array();

	foreach ($id_arr as $key => $id) {

		$order = get_post_meta( $id, 'order', true );
		$menu_order_arr[] = $order;
		
	}

	sort($menu_order_arr);

	foreach ($data as $key => $values) {

		foreach ($values as $position => $id) {

			update_post_meta(intval($id), 'order', intval($menu_order_arr[$position]));

		}
	}

	exit;
	
}


function alexandria_orden_interlocutors_ajax() {

	parse_str($_POST['order'], $data);

	if (!is_array($data))
		return false;

	$id_arr = array();
	foreach ($data as $key => $values) {
		foreach ($values as $position => $id) {
			$id_arr[] = $id;
		}
	}

	$menu_order_arr = array();

	foreach ($id_arr as $key => $id) {

		$order = get_post_meta( $id, 'order', true );
		$menu_order_arr[] = $order;
		
	}

	sort($menu_order_arr);

	foreach ($data as $key => $values) {

		foreach ($values as $position => $id) {

			update_post_meta(intval($id), 'order', intval($menu_order_arr[$position]));

		}
	}

	exit;
	
}

