<?php

/**
 * Loading Spinner Partial.
 *
 * @link https://developer.wordpress.org/themes/basics/template-hierarchy/#single-post
 *
 * @package Alexandria_Conversation_Builder
 * @subpackage Alexandria_Conversation_Builder/public/templates
 */

if ( ! defined( 'ABSPATH' ) ) { exit; } // Exit if accessed directly

?>

<div id="alexandriaLoading" class="alexandria-loader-container" style="display: none;">

	<div class="alexandria-loader-spinner-wrapper">
		<div class="alexandria-loader-spinner"><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div></div>
	</div>

	<div class="alexandria-loader-text-wrapper">
		<span class="alexandria-loader-text">
			<?php _e('Cargando...','alexandria-conversation-builder'); ?>
		</span>
	</div>

</div>